
_Main_Init:

;electronique_gradateur_012a_12f675.mpas,17 :: 		begin
;electronique_gradateur_012a_12f675.mpas,18 :: 		CMCON := 7;           // comparators OFF (CMCON = 7)
	MOVLW      7
	MOVWF      CMCON+0
;electronique_gradateur_012a_12f675.mpas,20 :: 		TRISIO := %00001001;  // all output, except GP0/AN0 used as input
	MOVLW      9
	MOVWF      TRISIO+0
;electronique_gradateur_012a_12f675.mpas,22 :: 		INTCON := 0;
	CLRF       INTCON+0
;electronique_gradateur_012a_12f675.mpas,23 :: 		INTCON.GIE := 1;   // enable global interrupts;
	BSF        INTCON+0, 7
;electronique_gradateur_012a_12f675.mpas,24 :: 		INTCON.PEIE := 1;  // needed for ADConv end int to occur
	BSF        INTCON+0, 6
;electronique_gradateur_012a_12f675.mpas,25 :: 		INTCON.T0IE := 1;  // enable Timer0 int
	BSF        INTCON+0, 5
;electronique_gradateur_012a_12f675.mpas,27 :: 		IOC := 0;          // disable Interrupt On Change
	CLRF       IOC+0
;electronique_gradateur_012a_12f675.mpas,28 :: 		T1CON := 0;        // disable Timer1
	CLRF       T1CON+0
;electronique_gradateur_012a_12f675.mpas,30 :: 		WPU := 0;                  // disable pull-up
	CLRF       WPU+0
;electronique_gradateur_012a_12f675.mpas,31 :: 		OPTION_REG := 0;
	CLRF       OPTION_REG+0
;electronique_gradateur_012a_12f675.mpas,32 :: 		OPTION_REG.NOT_GPPU := 1;  // disable pull-up
	BSF        OPTION_REG+0, 7
;electronique_gradateur_012a_12f675.mpas,36 :: 		OPTION_REG.PSA  := 1;  // bit 3 Prescaler Assignment bit: 0=Prescaler is assigned to the Timer0
	BSF        OPTION_REG+0, 3
;electronique_gradateur_012a_12f675.mpas,37 :: 		OPTION_REG.PS2  := 0;  // bits 2-0  PS2:PS0: Prescaler Rate Select bits
	BCF        OPTION_REG+0, 2
;electronique_gradateur_012a_12f675.mpas,38 :: 		OPTION_REG.PS1  := 0;
	BCF        OPTION_REG+0, 1
;electronique_gradateur_012a_12f675.mpas,39 :: 		OPTION_REG.PS0  := 0;
	BCF        OPTION_REG+0, 0
;electronique_gradateur_012a_12f675.mpas,40 :: 		TMR0 := cTMR0;         // preset for timer register
	MOVLW      236
	MOVWF      TMR0+0
;electronique_gradateur_012a_12f675.mpas,43 :: 		ADCON0 := 0;
	CLRF       ADCON0+0
;electronique_gradateur_012a_12f675.mpas,44 :: 		ADCON0.ADON := 1;      // turn on ADC module
	BSF        ADCON0+0, 0
;electronique_gradateur_012a_12f675.mpas,46 :: 		ADCON0.ADFM := 0;      // 0 = left justified, 1 = right justified
	BCF        ADCON0+0, 7
;electronique_gradateur_012a_12f675.mpas,47 :: 		ANSEL := 0;
	CLRF       ANSEL+0
;electronique_gradateur_012a_12f675.mpas,48 :: 		ANSEL.ANS0 := 1;       // set GP0 as analog input
	BSF        ANSEL+0, 0
;electronique_gradateur_012a_12f675.mpas,49 :: 		ADC_Init;
	CALL       _ADC_Init+0
;electronique_gradateur_012a_12f675.mpas,53 :: 		PIE1 := 0;
	CLRF       PIE1+0
;electronique_gradateur_012a_12f675.mpas,54 :: 		PIE1.ADIE := 1;   // enable ADC conv end int
	BSF        PIE1+0, 6
;electronique_gradateur_012a_12f675.mpas,55 :: 		PIR1 := 0;
	CLRF       PIR1+0
;electronique_gradateur_012a_12f675.mpas,59 :: 		OSCCAL := OSCCAL or %00111111;
	MOVLW      63
	IORWF      OSCCAL+0, 1
;electronique_gradateur_012a_12f675.mpas,61 :: 		GPIO   := %00000000;   // set all outputs to low state (GPIO3 read as 1)
	CLRF       GPIO+0
;electronique_gradateur_012a_12f675.mpas,62 :: 		AdcInOld := 0;
	CLRF       _AdcInOld+0
;electronique_gradateur_012a_12f675.mpas,63 :: 		AdcInNew := 63;
	MOVLW      63
	MOVWF      _AdcInNew+0
;electronique_gradateur_012a_12f675.mpas,64 :: 		PwmDuty := 50;
	MOVLW      50
	MOVWF      _PwmDuty+0
;electronique_gradateur_012a_12f675.mpas,66 :: 		end;
L_end_Main_Init:
	RETURN
; end of _Main_Init

_Interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;electronique_gradateur_012a_12f675.mpas,69 :: 		begin
;electronique_gradateur_012a_12f675.mpas,72 :: 		if INTCON.T0IF then
	BTFSS      INTCON+0, 2
	GOTO       L__Interrupt3
;electronique_gradateur_012a_12f675.mpas,75 :: 		bT0IntOccured := true;
	MOVLW      255
	MOVWF      _bT0IntOccured+0
;electronique_gradateur_012a_12f675.mpas,76 :: 		INTCON.T0IF := 0;
	BCF        INTCON+0, 2
;electronique_gradateur_012a_12f675.mpas,77 :: 		TMR0 := cTMR0;
	MOVLW      236
	MOVWF      TMR0+0
;electronique_gradateur_012a_12f675.mpas,78 :: 		end;
L__Interrupt3:
;electronique_gradateur_012a_12f675.mpas,81 :: 		if PIR1.ADIF then
	BTFSS      PIR1+0, 6
	GOTO       L__Interrupt6
;electronique_gradateur_012a_12f675.mpas,83 :: 		bADCIntOccured := true;
	MOVLW      255
	MOVWF      _bADCIntOccured+0
;electronique_gradateur_012a_12f675.mpas,84 :: 		PIR1.ADIF := 0;
	BCF        PIR1+0, 6
;electronique_gradateur_012a_12f675.mpas,85 :: 		end;
L__Interrupt6:
;electronique_gradateur_012a_12f675.mpas,87 :: 		end;
L_end_Interrupt:
L__Interrupt34:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _Interrupt

_ADC_GetValue:

;electronique_gradateur_012a_12f675.mpas,92 :: 		begin
;electronique_gradateur_012a_12f675.mpas,93 :: 		Out_Test2 := 1;
	BSF        GP4_bit+0, 4
;electronique_gradateur_012a_12f675.mpas,98 :: 		else
L__ADC_GetValue10:
;electronique_gradateur_012a_12f675.mpas,100 :: 		bADCIntOccured := false;
	CLRF       _bADCIntOccured+0
;electronique_gradateur_012a_12f675.mpas,102 :: 		ADCON0.ADFM := 1;      // 0 = left justified, 1 = right justified
	BSF        ADCON0+0, 7
;electronique_gradateur_012a_12f675.mpas,103 :: 		ADCON0.1 := 1;
	BSF        ADCON0+0, 1
;electronique_gradateur_012a_12f675.mpas,104 :: 		PIR1.ADIF := 1;
	BSF        PIR1+0, 6
;electronique_gradateur_012a_12f675.mpas,105 :: 		repeat
L__ADC_GetValue12:
;electronique_gradateur_012a_12f675.mpas,106 :: 		delay_us(1);
	NOP
;electronique_gradateur_012a_12f675.mpas,107 :: 		until (PIR1.ADIF = 0){bADCIntOccured};
	BTFSS      PIR1+0, 6
	GOTO       L__ADC_GetValue15
	GOTO       L__ADC_GetValue12
L__ADC_GetValue15:
;electronique_gradateur_012a_12f675.mpas,111 :: 		AdcInNew := (ADRESH shr 1);  // get 7 MSB value
	MOVF       ADRESH+0, 0
	MOVWF      _AdcInNew+0
	RRF        _AdcInNew+0, 1
	BCF        _AdcInNew+0, 7
;electronique_gradateur_012a_12f675.mpas,113 :: 		Out_Test2 := 0;
	BCF        GP4_bit+0, 4
;electronique_gradateur_012a_12f675.mpas,114 :: 		end;
L_end_ADC_GetValue:
	RETURN
; end of _ADC_GetValue

_main:

;electronique_gradateur_012a_12f675.mpas,116 :: 		begin
;electronique_gradateur_012a_12f675.mpas,117 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_gradateur_012a_12f675.mpas,119 :: 		while true do
L__main19:
;electronique_gradateur_012a_12f675.mpas,123 :: 		if bT0IntOccured then
	MOVF       _bT0IntOccured+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main24
;electronique_gradateur_012a_12f675.mpas,125 :: 		Out_Test := Out_Test xor 1;
	MOVLW      4
	XORWF      GP2_bit+0, 1
;electronique_gradateur_012a_12f675.mpas,126 :: 		if iStepPWM < 127 then
	MOVLW      127
	SUBWF      _iStepPWM+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__main27
;electronique_gradateur_012a_12f675.mpas,127 :: 		inc(iStepPWM)
	INCF       _iStepPWM+0, 1
	GOTO       L__main28
;electronique_gradateur_012a_12f675.mpas,128 :: 		else
L__main27:
;electronique_gradateur_012a_12f675.mpas,129 :: 		iStepPWM := 0;
	CLRF       _iStepPWM+0
L__main28:
;electronique_gradateur_012a_12f675.mpas,130 :: 		Out_PWM := (PwmDuty > iStepPWM);
	MOVF       _PwmDuty+0, 0
	SUBWF      _iStepPWM+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	BTFSC      R0+0, 0
	GOTO       L__main37
	BCF        GP1_bit+0, 1
	GOTO       L__main38
L__main37:
	BSF        GP1_bit+0, 1
L__main38:
;electronique_gradateur_012a_12f675.mpas,131 :: 		bT0IntOccured := false;
	CLRF       _bT0IntOccured+0
;electronique_gradateur_012a_12f675.mpas,132 :: 		end;
L__main24:
;electronique_gradateur_012a_12f675.mpas,135 :: 		ADC_GetValue;
	CALL       _ADC_GetValue+0
;electronique_gradateur_012a_12f675.mpas,137 :: 		if AdcInNew <> AdcInOld then
	MOVF       _AdcInNew+0, 0
	XORWF      _AdcInOld+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__main30
;electronique_gradateur_012a_12f675.mpas,139 :: 		PwmDuty := AdcInNew;
	MOVF       _AdcInNew+0, 0
	MOVWF      _PwmDuty+0
;electronique_gradateur_012a_12f675.mpas,140 :: 		AdcInOld := AdcInNew;
	MOVF       _AdcInNew+0, 0
	MOVWF      _AdcInOld+0
;electronique_gradateur_012a_12f675.mpas,141 :: 		end;
L__main30:
;electronique_gradateur_012a_12f675.mpas,143 :: 		end;
	GOTO       L__main19
;electronique_gradateur_012a_12f675.mpas,144 :: 		end.
L_end_main:
	GOTO       $+0
; end of _main
